const express = require('express')
const bodyParser = require('body-parser')
const { engine } = require('express-handlebars')
const WebSocket = require('ws')

var port = process.env.PORT || 3000
const app = express()
app.use(bodyParser.urlencoded({ extended: false }))
app.use(express.static('static'))
app.engine('html', engine({ extname: '.html' }))
app.set('view engine', 'html')
app.set('views', './views')

const messages = []

app.get('/', (req, res) => {
  res.render("index", { messages, layout: false });
});

const wss = new WebSocket.Server({ port: port + 1 });
wss.on('connection', (ws) => {
  const i = wss.clients.size - 1;
  ws.on('message', (message) => {
    let j = 0;
    wss.clients.forEach((client) => {
      if ((ws === client || ((i + j) % 2)) && client.readyState === WebSocket.OPEN) {
        client.send(message)
      }
      j += 1;
    })
  })
})

app.listen(port)
console.log(`Server running on http://localhost:${port}, WebSocket on port ${port + 1}`)

